Name:           ltsp
Version:        5.1.13
%define _datestamp .20080718.14
#Release:        0%{_datestamp}%{?dist}
Release:        2%{?dist}
Summary:        Linux Terminal Server Project Server and Client
Group:          User Interface/Desktops

License:        GPLv2 and GPLv2+
URL:            http://www.ltsp.org
#   bzr branch http://bazaar.launchpad.net/~ltsp-upstream/ltsp/ltsp-trunk
#   cd ltsp-trunk
#   mkdst tar --from-tag=ltsp-%{version}
Source0:        ltsp-%{version}.tar.bz2
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
%if 0%{?fedora} > 7 || 0%{?rhel} > 5
BuildRequires: popt-devel
%else
BuildRequires: popt
%endif
BuildRequires: flex bison
BuildRequires: automake
BuildRequires: pkgconfig
BuildRequires: libX11-devel
%ifarch %{ix86} x86_64
# Need pxelinux.0 from syslinux if server is x86
BuildRequires: syslinux
%endif
BuildRequires: tftp-server

# tftpboot directory location changed in F9+
%if 0%{?fedora} > 8 || 0%{?rhel} > 5
%define _tftpdir /var/lib/tftpboot
%else
%define _tftpdir /tftpboot
%endif

%description
LTSP client and server

%if 0%{?fedora}
%package client
Summary:        LTSP client
Group:          User Interface/Desktops
Requires:       chkconfig
Requires:       ltspfsd

%description client
LTSP client package
This package contains the scripts necessary to boot as a LTSP5 thin client.
%endif

%package server
Summary:        LTSP server
Group:          User Interface/Desktops
%if 0%{?fedora}
# needed to install client chroots
Requires:       livecd-tools >= 015
%endif
Requires:       tftp-server
Requires:       ltspfs
Requires:       dhcp
Requires:       gettext
Requires:       bridge-utils
Requires(post): chkconfig
Requires(preun): chkconfig

%description server
LTSP server package
This package contains the scripts and services necessary to install and run
a Linux Terminal Server.

%if 0%{?fedora}
%ifarch %{ix86} x86_64
%package vmclient
Summary:        LTSP Virtual Machine Client
Group:          Applications/Emulators
Requires:       kvm

%description vmclient
Run a qemu-kvm virtual machine as a PXE client.  This allows you to test a 
LTSP server without the hassle of having extra hardware.  Requires 
your system to support hardware virtualization or it will be very slow.
%endif
%endif


%prep
%setup -q 

%build
pushd client/getltscfg
  make %{?_smp_mflags}
popd

pushd client/xrexecd
  %configure
  make %{?_smp_mflags}
popd


%install
##### make directories
rm -rf $RPM_BUILD_ROOT
%if 0%{?fedora}
# client
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1/
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/rwtab.d/
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/X11/
mkdir -p $RPM_BUILD_ROOT%{_datadir}/ltsp/
mkdir -p $RPM_BUILD_ROOT%{_datadir}/ltsp/chroot-setup.d/
%endif

# server
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man8
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/ltsp/
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/ltsp/kickstart/
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/ltsp/mkinitrd/
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/init.d/
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/ltsp/scripts/
mkdir -p $RPM_BUILD_ROOT%{_datadir}/ltsp/scripts.d/
mkdir -p $RPM_BUILD_ROOT%{_datadir}/ltsp/chkconfig.d/
mkdir -p $RPM_BUILD_ROOT%{_datadir}/ltsp/plugins/
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/cron.daily/
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/ltsp/swapfiles/
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d/
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/network-scripts/
mkdir -p $RPM_BUILD_ROOT/opt/ltsp

mkdir -p $RPM_BUILD_ROOT%{_tftpdir}/ltsp/i386/pxelinux.cfg/
mkdir -p $RPM_BUILD_ROOT%{_tftpdir}/ltsp/x86_64/pxelinux.cfg/
mkdir -p $RPM_BUILD_ROOT%{_tftpdir}/ltsp/ppc/
mkdir -p $RPM_BUILD_ROOT%{_tftpdir}/ltsp/ppc64/

%if 0%{?fedora}
###### client install
pushd client/xrexecd
    make install DESTDIR=$RPM_BUILD_ROOT
popd

install -m 0755 client/getltscfg/getltscfg $RPM_BUILD_ROOT/%{_bindir}/getltscfg
install -m 0644 client/getltscfg/getltscfg.1 $RPM_BUILD_ROOT/%{_mandir}/man1/
install -m 0644 client/ltsp_config $RPM_BUILD_ROOT/%{_datadir}/ltsp/
install -m 0755 client/screen_session $RPM_BUILD_ROOT/%{_datadir}/ltsp/
install -m 0755 client/configure-x.sh $RPM_BUILD_ROOT/%{_datadir}/ltsp/
install -m 0644 client/initscripts/ltsp-init-common $RPM_BUILD_ROOT/%{_datadir}/ltsp/
install -m 0644 ltsp-common-functions $RPM_BUILD_ROOT/%{_datadir}/ltsp/
install -m 0755 client/initscripts/RPM/ltsp-client-launch $RPM_BUILD_ROOT%{_sbindir}
install -m 0644 client/rwtab.d/k12linux.rwtab $RPM_BUILD_ROOT%{_sysconfdir}/rwtab.d
install -m 0644 client/screen-x-common $RPM_BUILD_ROOT/%{_datadir}/ltsp/
install -m 0755 client/jetpipe/jetpipe $RPM_BUILD_ROOT/%{_sbindir}
install -m 0644 client/jetpipe/jetpipe.8 $RPM_BUILD_ROOT/%{_mandir}/man8/
install -m 0700 client/chroot-setup/ltsp-chroot-setup $RPM_BUILD_ROOT/%{_datadir}/ltsp/
cp -av client/chroot-setup/k12linux/* $RPM_BUILD_ROOT%{_datadir}/ltsp/chroot-setup.d/
cp -av client/screen.d $RPM_BUILD_ROOT/%{_datadir}/ltsp/
touch $RPM_BUILD_ROOT%{_sysconfdir}/lts.conf
touch $RPM_BUILD_ROOT%{_localstatedir}/lib/random-seed
%endif

### server install
install -m 0755 server/nbdrootd $RPM_BUILD_ROOT%{_sbindir}
install -m 0755 server/nbdswapd $RPM_BUILD_ROOT%{_sbindir}
install -m 0755 server/ldminfod $RPM_BUILD_ROOT%{_sbindir}
install -m 0755 server/ltsp-update-sshkeys $RPM_BUILD_ROOT%{_sbindir}
%if 0%{?fedora}
install -m 0755 server/ltsp-build-client $RPM_BUILD_ROOT%{_sbindir}
cp -pr server/plugins/* $RPM_BUILD_ROOT%{_datadir}/ltsp/plugins/
%endif
install -m 0755 server/ltsp-update-kernels $RPM_BUILD_ROOT%{_sbindir}
install -m 0755 server/scripts/k12linux/chroot-creator $RPM_BUILD_ROOT%{_sbindir}
install -m 0755 server/ltsp-swapfile-delete $RPM_BUILD_ROOT%{_sysconfdir}/cron.daily/
install -m 0644 server/xinetd.d/nbdrootd $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d/
install -m 0644 server/xinetd.d/nbdswapd $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d/
install -m 0644 server/xinetd.d/ldminfod $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d/
install -m 0644 server/configs/nbdswapd.conf $RPM_BUILD_ROOT%{_sysconfdir}/ltsp/
cp -pr server/configs/kickstart/* $RPM_BUILD_ROOT%{_sysconfdir}/ltsp/kickstart/
install -m 0644 server/configs/k12linux/mkinitrd/ifcfg-eth0 $RPM_BUILD_ROOT%{_sysconfdir}/ltsp/mkinitrd/
install -m 0644 server/configs/k12linux/mkinitrd/sysconfig-mkinitrd $RPM_BUILD_ROOT%{_sysconfdir}/ltsp/mkinitrd/
install -m 0644 server/configs/k12linux/mkinitrd/sysconfig-network $RPM_BUILD_ROOT%{_sysconfdir}/ltsp/mkinitrd/
install -m 0644 server/services/sysconfig-ltsp-dhcpd $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/ltsp-dhcpd
install -m 0755 server/services/ltsp-dhcpd.init $RPM_BUILD_ROOT%{_sysconfdir}/init.d/ltsp-dhcpd
install -m 0755 server/scripts/k12linux/ltsp-prepare-kernel $RPM_BUILD_ROOT/%{_sbindir}/
install -m 0755 server/scripts/k12linux/ltsp-server-initialize $RPM_BUILD_ROOT/%{_sbindir}/
install -m 0755 server/scripts/k12linux/hosts-update $RPM_BUILD_ROOT/%{_datadir}/ltsp/scripts/
install -m 0755 server/scripts/k12linux/dhcpd-update $RPM_BUILD_ROOT/%{_datadir}/ltsp/scripts/
cp -p server/scripts/k12linux/scripts.d/*   $RPM_BUILD_ROOT%{_datadir}/ltsp/scripts.d/
cp -p server/scripts/k12linux/chkconfig.d/* $RPM_BUILD_ROOT%{_datadir}/ltsp/chkconfig.d/

# configs
install -m 0644 server/configs/k12linux/ifcfg-ltspbr0 $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/network-scripts/
install -m 0644 server/configs/k12linux/ltsp-dhcpd.conf $RPM_BUILD_ROOT%{_sysconfdir}/ltsp/dhcpd.conf
install -m 0644 server/configs/k12linux/ltsp-update-kernels.conf $RPM_BUILD_ROOT%{_sysconfdir}/ltsp/
install -m 0644 server/configs/k12linux/ltsp-build-client.conf $RPM_BUILD_ROOT%{_sysconfdir}/ltsp/
install -m 0644 server/configs/k12linux/ltsp-server.conf $RPM_BUILD_ROOT%{_sysconfdir}/ltsp/

for arch in i386 x86_64 ppc ppc64; do
    install -m 0644 server/configs/k12linux/lts.conf $RPM_BUILD_ROOT%{_tftpdir}/ltsp/$arch/
done

echo "LTSPDIST=%{dist}" | sed 's/\.//' > $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/ltspdist
cat server/configs/k12linux/ltspdist.template >> $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/ltspdist

%ifarch %{ix86} x86_64
# PXE
install -m 0644 server/configs/pxe-default.conf $RPM_BUILD_ROOT%{_tftpdir}/ltsp/i386/pxelinux.cfg/default
install -m 0644 server/configs/pxe-default.conf $RPM_BUILD_ROOT%{_tftpdir}/ltsp/x86_64/pxelinux.cfg/default
install -m 0644 /usr/lib/syslinux/pxelinux.0 $RPM_BUILD_ROOT%{_tftpdir}/ltsp/i386
install -m 0644 /usr/lib/syslinux/pxelinux.0 $RPM_BUILD_ROOT%{_tftpdir}/ltsp/x86_64
%endif

%if 0%{?fedora}
%ifarch %{ix86} x86_64
# vmclient
install -m 0755 vmclient/ltsp-vmclient           $RPM_BUILD_ROOT%{_sbindir}/
install -m 0755 vmclient/ltsp-qemu-bridge-ifup   $RPM_BUILD_ROOT%{_sbindir}/
install -m 0644 vmclient/config-vmclient         $RPM_BUILD_ROOT%{_sysconfdir}/ltsp/vmclient
%endif
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if 0%{?fedora}
%post client
/usr/share/ltsp/ltsp-chroot-setup
%endif

%post server
/sbin/chkconfig --add ltsp-dhcpd

%preun server
if [ $1 = 0 ]; then
    /sbin/service ltsp-dhcpd status >/dev/null 2>&1
    if [ $? = 3 ]; then
        /sbin/service ltsp-dhcpd stop >/dev/null 2>&1
    fi

    /sbin/chkconfig --del ltsp-dhcpd || :
    /sbin/service xinetd reload > /dev/null 2>&1 || :
fi

%postun server
if [ $1 -ge 1 ]; then
    /sbin/service ltsp-dhcpd condrestart >/dev/null 2>&1
fi

%if 0%{?fedora}
%files client
%defattr(-,root,root,-)
%{_mandir}/man1/getltscfg.1.gz
%{_bindir}/getltscfg
%{_bindir}/xrexecd
%{_sbindir}/ltsp-client-launch
%dir %{_datadir}/ltsp
%{_datadir}/ltsp/configure-x.sh
%{_datadir}/ltsp/ltsp-init-common
%{_datadir}/ltsp/ltsp-common-functions
%{_datadir}/ltsp/ltsp_config
%{_datadir}/ltsp/screen_session
%{_datadir}/ltsp/screen-x-common
%{_datadir}/ltsp/screen.d/
%{_sbindir}/jetpipe
%{_mandir}/man8/jetpipe.8.gz
%{_datadir}/ltsp/ltsp-chroot-setup
%{_datadir}/ltsp/chroot-setup.d/

# readonly-root related files
%{_sysconfdir}/rwtab.d/*
%{_localstatedir}/lib/random-seed
%config(noreplace) %{_sysconfdir}/lts.conf
%endif

%files server
%defattr(-,root,root,-)
%doc ChangeLog COPYING TODO server/doc/lts-parameters.txt
%dir %{_localstatedir}/lib/ltsp/
%dir %{_localstatedir}/lib/ltsp/swapfiles/
%dir %{_tftpdir}/
%dir %{_tftpdir}/ltsp/
%dir %{_tftpdir}/ltsp/i386/
%dir %{_tftpdir}/ltsp/i386/pxelinux.cfg/
%dir %{_tftpdir}/ltsp/x86_64/
%dir %{_tftpdir}/ltsp/x86_64/pxelinux.cfg/
%dir %{_tftpdir}/ltsp/ppc/
%dir %{_tftpdir}/ltsp/ppc64/
%ifarch %{ix86} x86_64
%{_tftpdir}/ltsp/i386/pxelinux.0
%{_tftpdir}/ltsp/x86_64/pxelinux.0
%config(noreplace) %{_tftpdir}/ltsp/i386/pxelinux.cfg/default
%config(noreplace) %{_tftpdir}/ltsp/x86_64/pxelinux.cfg/default
%endif

%dir /opt/ltsp

%if 0%{?fedora}
%{_sbindir}/ltsp-build-client
%{_datadir}/ltsp/plugins/
%endif
%{_sbindir}/ltsp-prepare-kernel
%{_sbindir}/ltsp-server-initialize
%{_sbindir}/ltsp-update-kernels
%{_datadir}/ltsp/scripts/
%{_datadir}/ltsp/scripts.d/
%{_datadir}/ltsp/chkconfig.d/
%{_sbindir}/ldminfod
%{_sbindir}/ltsp-update-sshkeys
%{_sbindir}/nbdrootd
%{_sbindir}/nbdswapd
%{_sbindir}/chroot-creator
%{_sysconfdir}/cron.daily/ltsp-swapfile-delete
%{_sysconfdir}/init.d/ltsp-dhcpd
%{_sysconfdir}/sysconfig/ltspdist
%config(noreplace) %{_sysconfdir}/xinetd.d/nbdrootd
%config(noreplace) %{_sysconfdir}/xinetd.d/nbdswapd
%config(noreplace) %{_sysconfdir}/xinetd.d/ldminfod
%dir %{_sysconfdir}/ltsp/
# Configuration Files
%config(noreplace) %{_sysconfdir}/sysconfig/ltsp-dhcpd
%config(noreplace) %{_sysconfdir}/sysconfig/network-scripts/ifcfg-ltspbr0
%config(noreplace) %{_sysconfdir}/ltsp/nbdswapd.conf 
%config(noreplace) %{_sysconfdir}/ltsp/ltsp-build-client.conf
%config(noreplace) %{_sysconfdir}/ltsp/ltsp-server.conf
%config(noreplace) %{_sysconfdir}/ltsp/dhcpd.conf
%config(noreplace) %{_sysconfdir}/ltsp/ltsp-update-kernels.conf
%dir %{_sysconfdir}/ltsp/kickstart/
%dir %{_sysconfdir}/ltsp/kickstart/Fedora/
%config(noreplace) %{_sysconfdir}/ltsp/kickstart/Fedora/common.ks
%dir %{_sysconfdir}/ltsp/kickstart/Fedora/8/
%dir %{_sysconfdir}/ltsp/kickstart/Fedora/9/
%config(noreplace) %{_sysconfdir}/ltsp/kickstart/*/*/*.ks
%dir %{_sysconfdir}/ltsp/mkinitrd/
%config(noreplace) %{_sysconfdir}/ltsp/mkinitrd/*
%config(noreplace) %{_tftpdir}/ltsp/*/lts.conf

%if 0%{?fedora}
%ifarch %{ix86} x86_64
%files vmclient
%defattr(-,root,root,-)
%{_sbindir}/ltsp-vmclient
%{_sbindir}/ltsp-qemu-bridge-ifup
%config(noreplace) %{_sysconfdir}/ltsp/vmclient
%endif
%endif

%changelog
* Fri Jul 18 2008 Warren Togami <wtogami@redhat.com> - 5.1.13-2
- Add some spec conditionals for RHEL5.
  RHEL5 has only ltsp-server.  Client chroot must be
  Fedora 9+, so there is no RHEL5 build of ltsp-client.
- Ensure that ltsp-chroot-setup is run after chroot creation.

* Wed Jul 16 2008 Warren Togami <wtogami@redhat.com> - 5.1.12-1
- Move some chroot setup into ltsp-client %%post so things can be fixed
  by ltsp-client package updates in the future.

* Thu Jul 10 2008 Warren Togami <wtogami@redhat.com> - 5.1.11-1
- LDM_DIRECTX=yes unencrypted X by default in lts.conf
  This is for performance and scalability.  Turn it off if you want security.
- Fix chroot install that was broken by livecd-tools update
- own /var/lib/ltsp to silence tmpwatch selinux errors

* Fri Jun 06 2008 Warren Togami <wtogami@redhat.com> - 5.1.9-1
- jetpipe script was missing from ltsp-client
  This should allow local printers to work if configured in lts.conf.

* Fri May 16 2008 Warren Togami <wtogami@redhat.com> - 5.1.8-1
- Fix NBD swap
- Fix grabbing of lts.conf, it happens from the rootfs server now

* Wed Apr 30 2008 Warren Togami <wtogami@redhat.com> - 5.1.7-2
- Allow ltsp-build-client to work in sudo

* Mon Apr 28 2008 Warren Togami <wtogami@redhat.com> - 5.1.7-1
- Fix ltsp-server-initialize (eharrison)
- Create /etc/mtab in chroot, fixes ltspfs (wtogami)

* Sun Apr 27 2008 Warren Togami <wtogami@redhat.com> - 5.1.6-1
- set LANG for login screen from client's /etc/sysconfig/i18n
- move /etc/ltsp/ltsp-dhcpd.conf to /etc/ltsp/dhcpd.conf for consistency with Debian
- vmclient split out config file into /etc/ltsp/vmclient

* Thu Apr 17 2008 Warren Togami <wtogami@redhat.com> - 5.1.5-1
- fix race condition in client/getltscfg/Makefile
- include lts-parameters.txt in ltsp-server docs

* Thu Apr 17 2008 Warren Togami <wtogami@redhat.com> - 5.1.4-1
- Use F9 instead of rawhide configs for chroot install (#442732)
- Bug fix: configure /etc/hosts only once
- configure_swap(), configure_printer(), configure_serial_mouse() during
  client startup.  Possibly fixes #442649.

* Sun Mar 30 2008 Warren Togami <wtogami@redhat.com> - 5.1.3-1
- Fix sound, though still needs more work       (#436906 eharrison)
- Make F9 client boot work w/ event-compat-sysv (#442291 eharrison)

* Sun Mar 30 2008 Warren Togami <wtogami@redhat.com> - 5.1.2-1
- 5.1.2

* Sun Mar 30 2008 Warren Togami <wtogami@redhat.com> - 5.1.1-1
- 5.1.1

* Tue Mar 25 2008 Warren Togami <wtogami@redhat.com> - 5.1.0-0.8.20080325.22
- screen-x-common had a crippling typo
- other minor fixes

* Mon Mar 24 2008 Warren Togami <wtogami@redhat.com> - 5.1.0-0.7.20080324.11
- screen-x-common to unify X configuration between screen scripts
- boot clients faster (avoid ipcalc -h lookup delay in the absence of DNS)

* Wed Mar 19 2008 Warren Togami <wtogami@redhat.com> - 5.1.0-0.6.20080319
- ltsp-server requires bridge-utils
- Verifies tftpdir during ltsp-build-client (#436911)

* Tue Mar 18 2008 Warren Togami <wtogami@redhat.com> - 5.1.0-0.4.20080318
- Ugly hacks to allow yum to work in the chroot without mounting /proc
- Allow ltsp-build-client to work in sudo (/usr/sbin isn't in PATH)
- Fix i586 client grabbing of lts.conf from tftp
- Various other small fixes

* Mon Mar 10 2008 Warren Togami <wtogami@redhat.com> - 5.1.0-0.3.20080310
- make ppc build work
  Wont work yet, requires a kickstart file and possibly fixes elsewhere.

* Mon Mar 10 2008 Warren Togami <wtogami@redhat.com> - 5.1.0-0.2.20080310
- improve init.d/ltsp-dhcpd script so restart works properly
- add %%post and %%preun handling of ltsp-dhcpd
- other spec fixes from mdomsch's review

* Mon Mar 10 2008 Warren Togami <wtogami@redhat.com> - 5.1.0-0.1.20080310
- initial package for review
